 /*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

 

/* I N C L U D E S ---------------------------------------------------------- */
#include "via.h"
#include "capture.h"
#include "ddmpeg.h"

#include "regrec.h"     /* for Macro_VidREGRec funcs */
#include "Vinline.h"    /* Universal wait function */
#include "ddover.h"
#include "VidStruc.h"   /* VIDDATA, video top level structure */
#include "debug.h"      /* for DBG_DD */
#include "vdefCME.h"
#include "vregCME.h"


/* F U N C T I O N ---------------------------------------------------------- */
int VIA_ALPSetFrameBuffer(PVIDDATA pVidData, LPALPHADEVICE lpDevice)
{
    unsigned char* pjVideo = pVidData->Vhwinfo.pjVideo;
    
    DBG_DD(("\n"));

    VIDOutD(V_ALPHA_STARTADDR,lpDevice->dwALPPhysicalAddr);

    VIDOutD(V_ALPHA_STRIDE,lpDevice->dwPitch);

    VIDOutD(V3_ALPHA_FETCH_COUNT,(VIDInD(V3_ALPHA_FETCH_COUNT) &(~0x3ff)) | ((lpDevice->dwPitch)>>4));

    DBG_DD(("00000224 %08lx\n",lpDevice->dwALPPhysicalAddr));
    DBG_DD(("0000021C %08lx\n",lpDevice->dwPitch));
    DBG_DD(("000002B8 %08lx\n",VIDInD(V3_ALPHA_FETCH_COUNT)));

    return VMI_OK;

} /* VIA_ALPSetFrameBuffer */

