/*
 * Copyright 1998-2008 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2008 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
/* ------- mergedfb support ------ */
		/* Psuedo Xinerama support */
#define NEED_REPLIES  		
#define EXTENSION_PROC_ARGS void *
#include "extnsionst.h"  	/* required */
#include "panoramiXproto.h"  	/* required */
#define VIA_XINERAMA_MAJOR_VERSION  1
#define VIA_XINERAMA_MINOR_VERSION  1
#ifndef _VIA_BIOS_H_
#define _VIA_BIOS_H_ 1

#define IGA1	    1
#define IGA2	    2
#define IGA1_IGA2   3

#define SCREEN_INDEX_0  0
#define SCREEN_INDEX_1  1

#define     VIA_BIOS_REG_TABLE_MAX_NUM      32
#define     VIA_BIOS_REG_LCD_MAX_NUM        48
#define     VIA_BIOS_NUM_RES                17
#define     VIA_BIOS_NUM_REFRESH            5
#define     VIA_BIOS_NUM_LCD_SUPPORT_MASK   8
#define     VIA_BIOS_NUM_LCD_POWER_SEQ      4
#define     VIA_BIOS_NUM_PANEL              11
#define     VIA_BIOS_MAX_NUM_MPATCH2        18
#define     VIA_BIOS_MAX_NUM_MPATCH1        9
#define     VIA_BIOS_MAX_NUM_CTREXP         5


/* The position of some BIOS information from start of BIOS */
#define     VIA_BIOS_SIZE_POS               0x2
#define     VIA_BIOS_OFFSET_POS             0x1B

/* The offset of table from table start */
#define     VIA_BIOS_CSTAB_POS              6
#define     VIA_BIOS_STDVGAREGTAB_POS       8
#define     VIA_BIOS_COMMEXTREGTAB_POS      10
#define     VIA_BIOS_STDMODEXTREGTAB_POS    12
#define     VIA_BIOS_EXTMODEREGTAB_POS      14
#define     VIA_BIOS_REFRESHMODETAB_POS     16
#define     VIA_BIOS_BIOSVER_POS            18
#define     VIA_BIOS_BCPPOST_POS            20
#define     VIA_BIOS_LCDMODETAB_POS         40
#define     VIA_BIOS_MODEOVERTAB_POS        46
#define     VIA_BIOS_MODEFITTAB_POS         48
#define     VIA_BIOS_LCDPOWERON_POS         50
#define     VIA_BIOS_LCDPOWEROFF_POS        52
#define     VIA_BIOS_LCDMODEFIX_POS         54
#define     ZCR                             0x0
#define     ZSR                             0x1
#define     ZGR                             0x2

/* Video Mode Index (FB device driver's res. index)*/
#define M480x640        0x000
#define M640x480        0x001
#define M720x480        0x002
#define M720x576        0x003
#define M800x480        0x004
#define M800x600        0x005
#define M848x480        0x006
#define M852x480        0x007
#define M960x600        0x008
#define M1000x600       0x009
#define M1024x512       0x00A
#define M1024x576       0x00B
#define M1024x600       0x00C
#define M1024x768       0x00D
#define M1024x768_I     0x20D   /* Interlace Mode */
#define M1088x612       0x00E
#define M1152x720       0x00F
#define M1152x864       0x010
#define M1152x864_I     0x210   /* Interlace Mode */
#define M1200x720       0x011
#define M1280x600       0x012
#define M1280x720       0x013
#define M1280x768       0x014
#define M1280x800       0x015
#define M1280x960       0x016
#define M1280x1024      0x017
#define M1280x1024_I    0x217   /* Interlace Mode */
#define M1360x768       0x018
#define M1360x768_RB    0x118   /* Reduce Banking */
#define M1366x768       0x019
#define M1368x768       0x01A
#define M1400x1050      0x01B
#define M1400x1050_RB   0x11B   /* Reduce Banking */
#define M1440x900       0x01C
#define M1440x900_RB    0x11C   /* Reduce Banking */
#define M1440x1050      0x01D
#define M1600x900       0x01E
#define M1600x900_RB    0x11E   /* Reduce Banking */
#define M1600x1024      0x01F
#define M1600x1200      0x020
#define M1600x1200_I    0x220   /* Interlace Mode */
#define M1680x600       0x021
#define M1680x1050      0x022
#define M1680x1050_RB   0x122   /* Reduce Banking */
#define M1792x1344      0x023
#define M1856x1392      0x024
#define M1920x1080      0x025
#define M1920x1080_RB   0x125   /* Reduce Banking */
#define M1920x1080_I    0x225   /* Interlace Mode */
#define M1920x1200      0x026
#define M1920x1200_RB   0x126   /* Reduce Banking */
#define M1920x1440      0x027
#define M2048x1536      0x028
#define M800x480_GEN    0x029   /* General timing, only for LCD*/
#define M_INVALID       0xFFF


#define     VIA_REF_60HZ                    0x0001
#define     VIA_REF_56HZ                    0x0002
#define     VIA_REF_65HZ                    0x0004
#define     VIA_REF_70HZ                    0x0008
#define     VIA_REF_72HZ                    0x0010
#define     VIA_REF_75HZ                    0x0020
#define     VIA_REF_80HZ                    0x0040
#define     VIA_REF_85HZ                    0x0080
#define     VIA_REF_90HZ                    0x0100
#define     VIA_REF_100HZ                   0x0200
#define     VIA_REF_120HZ                   0x0400
#define     VIA_REF_86HZ                    0x0800       /* Interlaced */
#define     VIA_REF_94HZ                    0x1000       /* Interlaced */

#define     VIA_NUM_REFRESH_RATE            5
#define     VIA_PANEL6X4                    0
#define     VIA_PANEL8X6                    1
#define     VIA_PANEL10X7                   2
#define     VIA_PANEL12X7                   3
#define     VIA_PANEL12X10                  4
#define     VIA_PANEL14X10                  5
#define     VIA_PANEL14X9                   6
#define     VIA_PANEL12X8                   7
#define     VIA_PANEL8X4                    8
#define     VIA_PANEL1366X7                 9
#define     VIA_PANEL1360X7                 10
#define     VIA_PANEL1920x1080              11
#define     VIA_PANEL1920x1200              12
#define     VIA_PANEL10X6                   13
#define     VIA_PANEL16X12                  14
#define     VIA_PANEL1280X720               15
#define     VIA_PANEL480X640                16
#define     VIA_PANEL8X4_GEN                17
#define     VIA_PANEL_INVALID               255

#define     VIA_NONETRANSMITTER             0x00
#define     VIA_VT3191                      0x01
#define     VIA_CH7019A                     0x02
#define     VIA_CH7019B                     0x03
#define     VIA_CH7017                      0x04    /* Support 18/24 Bit Bus Width */
#define     VIA_CH7304                      0x05    /* Support Single Channel Only */
#define     VIA_CH7305                      0x06    /* Support Dual Channel Only */
#define     VIA_TTLTYPE                     0x07
#define     VIA_VT3192                      0x09
#define     VIA_VT3193                      0x0A
#define     VIA_SIL168                      0x0C
#define     VIA_VT1636                      0x0E    /* VT1636 LVDS. */
#define     VIA_Hardwired                   0x0F
#define     VIA_INTEGRATED_LVDS             0x41
#define     VIA_INTEGRATED_TMDS             0x42


#define     VIA_DEVICE_CRT1                 0x01
#define     VIA_DEVICE_LCD                  0x02
#define     VIA_DEVICE_DFP                  0x08
#define     VIA_DEVICE_CRT2                 0x10
#define     VIA_DEVICE_LCD2                 0x20
#define     VIA_DEVICE_DFP2                 0x80
#define     VIA_DEVICE_ALL                  0xFF


/* System Memory CLK */
#define		VIA_MEM_SDR66					0x00
#define		VIA_MEM_SDR100					0x01
#define		VIA_MEM_SDR133					0x02
#define		VIA_MEM_DDR200					0x03
#define		VIA_MEM_DDR266					0x04
#define		VIA_MEM_DDR333					0x05
#define		VIA_MEM_DDR400					0x06

/* Digital Output Bus Width */
#define		VIA_DI_12BIT					0x00
#define		VIA_DI_24BIT					0x01

#define     VIAGETBIOSDATE                  0x01
#define     VIAGETBIOSVER                   0x02

/* For KM400 or later, there are many cases for digital output.
 * We must distinguish which digital port has been using by device.
 */
/* Digital Output Bus Port */
#define     VIA_DI_NONE                     0x000
#define     VIA_DI_DVP0                     0x001
#define     VIA_DI_DVP1                     0x002
#define     VIA_DI_DFPHIGH                  0x004
#define     VIA_DI_DFPLOW                   0x008
#define     VIA_DI_DFPHIGHLOW               0x010
#define     VIA_DI_LVDS0                    0x020
#define     VIA_DI_LVDS1                    0x040
#define     VIA_DI_LVDS0LVDS1               0x080
#define     VIA_DI_TMDS                     0x100
#define     VIA_DI_LVDS0DVP1                0x200

/* For HW strapping issue. */
#define     SLOT_AMR       1
#define     SLOT_AGP       2

#define     NOT_FOUND_DEV               0
#define     FOUND_INTERNAL_DEV          1
#define     FOUND_EXTERNAL_DEV_BY_I2C   2
#define     FOUND_EXTERNAL_DEV_BY_GPIO  3

/* LVDS Transmitter I2C Slave Address */
#define     LVDS_I2C_ADDR_VT1636    0x80
#define     LVDS_I2C_ADDR_VT1631    0x70
#define     LVDS_I2C_ADDR_CHRONTEL  0xEA

/* Hardware layout for internal LVDS/TMDS. */
#define     HW_LAYOUT_LCD_ONLY          0x01
#define     HW_LAYOUT_DVI_ONLY          0x02
#define     HW_LAYOUT_LCD_DVI           0x03
#define     HW_LAYOUT_LCD_LCD2          0x04
#define     HW_LAYOUT_LCD_EXTERNAL_LCD2 0x10
#define     HW_LAYOUT_TTL_LCD           0x40

#define REVISION_VX800_A    0
#define REVISION_VX800_B    1 
#define REVISION_VX800_B2   2 

/* for mergedfb */
typedef enum {
    viaLeftOf,
    viaRightOf,
    viaAbove,
    viaBelow,
    viaClone
} VIAScrn2Rel;

/* for mergedfb */
typedef struct {
    int               bitsPerPixel;
    int               depth;
    int               displayWidth;
    int               pixel_code;
    int               pixel_bytes;
    DisplayModePtr    mode;
} VIAFBLayout;


typedef struct _VGABIOSVER
{
    CARD8   CoreBase;
    CARD8   ProductID;
    CARD8   MajorVer;
    CARD8   MinorVer;
} VGABIOSVER, *VGABIOSVERPtr;

typedef struct _GPIOI2C_INFO
{
    CARD8       bGPIOPort;
    CARD8       bSlaveAddr;
    int         I2C_WAIT_TIME;
    int         STARTTIMEOUT;
    int         BYTETIMEOUT;
    int         HOLDTIME;
    int         BITTIMEOUT;
} GPIOI2C_INFO, *PGPIOI2C_INFO;

typedef struct _VIABIOSSTDVGATABLE {
    CARD8           columns;
    CARD8           rows;
    CARD8           fontHeight;
    CARD16          pageSize;
    CARD8           SR[5];
    CARD8           misc;
    CARD8           CR[25];
    CARD8           AR[20];
    CARD8           GR[9];
} VIABIOSStdVGATableRec, *VIABIOSStdVGATablePtr;

typedef struct _VIAModeInfoPtr {
    int width;
    int height;
    int bpp;
    int modeno;
    CARD16  SupRefMask;     /* Support Refresh Rate Mask */
    struct _VIAModeInfoPtr *next;
} VIAModeInfoRec, *VIAModeInfoPtr;


typedef struct _VIABIOSREGTABLE {
    CARD8   port[VIA_BIOS_REG_TABLE_MAX_NUM];
    CARD8   offset[VIA_BIOS_REG_TABLE_MAX_NUM];
    CARD8   mask[VIA_BIOS_REG_TABLE_MAX_NUM];
    CARD8   data[VIA_BIOS_REG_TABLE_MAX_NUM];
    int     numEntry;
} VIABIOSRegTableRec, *VIABIOSRegTablePtr;


typedef struct _VIAVMODEENTRY {
    unsigned short          Width;
    unsigned short          Height;
    unsigned short          Bpp;
    unsigned short          Mode;
} VIAModeEntry, *VIAModeEntryPtr;

typedef struct _VIAREGTBL
{
    CARD8   port;
    CARD8   offset;
    CARD8   data;
} VIARegTblRec, *VIARegTblPtr;

typedef struct _VIALCDREGTBL
{
    CARD16  HDisplay;
    CARD16  VDisplay;
    CARD32  LCDClk;
    CARD32  VClk;
    VIARegTblRec  Reg[61];
} VIALCDRegTblRec, *VIALCDRegPtr;

typedef struct _VIALCDTBL
{
    CARD8               fpSize;
    VIALCDRegTblRec     VIALCDCtrTbl[9];
    VIALCDRegTblRec     VIALCDExpTbl[9];
} VIALCDTblRec, *VIALCDTblPtr;

typedef struct _VIALCDMODEENTRY {
    CARD16  LCDClk;
    CARD16  VClk;
    CARD16  LCDClk_12Bit;
    CARD16  VClk_12Bit;
    CARD8   port[VIA_BIOS_REG_LCD_MAX_NUM];
    CARD8   offset[VIA_BIOS_REG_LCD_MAX_NUM];
    CARD8   data[VIA_BIOS_REG_LCD_MAX_NUM];
    int     numEntry;
} VIALCDModeEntry, *VIALCDModeEntryPtr;


typedef struct _VIALCDMPATCHENTRY {
    CARD8   Mode;
    CARD16  LCDClk;
    CARD16  VClk;
    CARD16  LCDClk_12Bit;
    CARD16  VClk_12Bit;
    CARD8   port[VIA_BIOS_REG_LCD_MAX_NUM];
    CARD8   offset[VIA_BIOS_REG_LCD_MAX_NUM];
    CARD8   data[VIA_BIOS_REG_LCD_MAX_NUM];
    int     numEntry;
} VIALCDMPatchEntry, *VIALCDMPatchEntryPtr;


typedef struct _VIALCDMODEFIX {
    CARD8   reqMode[32];
    CARD8   fixMode[32];
    int     numEntry;
} VIALCDModeFixRec, *VIALCDModeFixRecPtr;


typedef struct _VIALCDPOWERSEQUENCE {
    CARD8   powerSeq;
    CARD8   port[4];
    CARD8   offset[4];
    CARD8   mask[4];
    CARD8   data[4];
    CARD16  delay[4];
    int     numEntry;
} VIALCDPowerSeqRec, *VIALCDPowerSeqRecPtr;


typedef struct _VIALCDMODETABLE {
    CARD8                   fpSize;
    CARD16                  SuptMode[VIA_BIOS_NUM_LCD_SUPPORT_MASK];    
} VIALCDModeTableRec, *VIALCDModePtr;


typedef struct _VIAVMODETABLE {
    unsigned short          BIOSVer;
    char *                  BIOSDate;
    unsigned short          NumModes;
    int                     NumPowerOn;
    int                     NumPowerOff;
    VIAModeEntryPtr         Modes;
    VIABIOSRegTableRec      commExtTable;
    VIABIOSRegTableRec      stdModeExtTable;
    VIALCDPowerSeqRec       powerOn[VIA_BIOS_NUM_LCD_POWER_SEQ];
    VIALCDPowerSeqRec       powerOff[VIA_BIOS_NUM_LCD_POWER_SEQ];
    VIALCDModeFixRec        modeFix;
} VIAModeTableRec, *VIAModeTablePtr;

typedef struct hwLock {
    volatile unsigned int lock;
    char                      padding[60];
} hwLock, *hwLockPtr;


typedef struct _CRTSETTINGINFO {
    int     ModeIndex;
    int     HActive;
    int     VActive;
    int     IGAPath;
    int     MonitorSizeH;
    int     MonitorSizeV;
    Bool    IsPanning;
    Bool    IsFlatMonitor;
    int     MaxPixelClock;
} CRTSETTINGINFO, *CRTSETTINGINFOPTR;


typedef struct _TMDSSETTINGINFO {
    unsigned char   ChipID;
    int             I2CPort;
    unsigned char   I2CAddress;    
    unsigned char   BusWidth;   /* Digital Output Bus Width */
    int             DFPSize;        /* DVI panel size */
    Bool    IsDualEdge;
    int     ModeIndex;
    int     HActive;
    int     VActive;
    int     IGAPath;
    CARD32     PanelSizeH;
    CARD32     PanelSizeV;
    Bool    IsPanning;
    Bool    IsDownScaling;
    int     MaxPixelClock;
    int     HDMINativesize;
    Bool    IsPreSetting;
    Bool   HasUserSetting;
} TMDSSETTINGINFO, *TMDSSETTINGINFOPTR;


typedef struct _LVDSSETTINGINFO {
    unsigned char   ChipID;
    int             I2CPort;
    unsigned char   I2CAddress;    
    unsigned char   BusWidth;   /* Digital Output Bus Width */
    Bool    IsDualEdge;     /* mean add-on card is 2CH or Dual or DDR */
    Bool    IsDithering;    /* Dithering Enable is for 18 bits panel and Disable is for 24 bits panel.*/
    int     DIPort;
    int     IGAPath;
    CARD32  VClk;           /* Clock of the mode table. */
    int     PanelSizeID;    /* LCD panel size ID */
    int     PanelSizeX;
    int     PanelSizeY;
    int     ModeIndex;
    int     HActive;
    int     VActive;
    Bool    Center;
    Bool    IsPanning;
    Bool    IsDownScaling;
    Bool    IsPreSetting;
    Bool    HasUserSetting;
    Bool    MsbEnable;           /* data ouput format is MSB or not */
} LVDSSETTINGINFO, *LVDSSETTINGINFOPTR;


typedef struct _IGASETTINGINFO {
    Bool    IsPanning;
	Bool    IsDownScaling;
    int     HActive;
    int     VActive;
    int     CountWidthByQWord;
    int     OffsetWidthByQWord;
    Bool    SetStartingAddrFirstTime;   /* If not panning, we can use this flag to force to reset */
                                        /* starting address when set mode. */
    Bool    IsActive;                   /* Use to indicate if this IGA is in use. */
    CARD16  deviceActived;
} IGASETTINGINFO, *IGASETTINGINFOPTR;


/***********************************************************************************/
/*                  Transmitter DPA Setting Structure                              */
/***********************************************************************************/
#include "via_tblDPASetting.h"

/* For adjusting DPA by option. (User Specified)*/
typedef struct VT1636_DPA_SETTING {
    int     PanelSizeID;
    CARD8   CLK_SEL_ST1;
    CARD8   CLK_SEL_ST2;
} VT1636DPASETTING, *VT1636DPASETTINGPTR;


typedef struct USER_DPA_SETTING_INFO {
    Bool                    HasUserSetting_Gfx;
    Bool                    HasUserSetting_VT1636;
    GFX_DPA_VALUE   GfxDPA;
    VT1636DPASETTING        VT1636DPA;
} USERDPASETTINGINFO, *USERDPASETTINGINFOPTR;

/***********************************************************************************/
/*                  VIA BIOS INFO Structure                                        */
/***********************************************************************************/
typedef struct _VIABIOSINFO {

    VIAModeTablePtr     pModeTable;

    int                 Chipset;
    int                 ChipRev;        
    
    unsigned char*      MapBase;
    Bool                FirstInit;
    unsigned char*      FBBase;
    unsigned long       videoRambytes;
    unsigned char       MemClk;
    int                 scrnIndex;

    VIAModeInfoPtr      VIAModeList;
    int                 modeNum;        /* VESA Mode Number */
    unsigned int        mode, refresh, resMode;
    int                 resMode2;       /* FB device driver's res. index */
    int                 countWidthByQWord;
    int                 offsetWidthByQWord;
    Bool                EnableExtendedFIFO;

    CARD16              ConnectedDevice;
    CARD16              ActiveDevice;
    CARD16              DefaultActiveDevice;
    
    CARD32              ActualActiveDevice;

    int                 DisplayHardwareLayout;          /* Hardware layout for internal LVDS/TMDS. */

    /* Here are all the BIOS Relative Options */
    int                 dwProjectIDRevision;
    int                 BIOSMajorVersion;
    int                 BIOSMinorVersion;
    unsigned char       BIOSDateYear;
    unsigned char       BIOSDateMonth;
    unsigned char       BIOSDateDay;
    Bool                MobileFamily;
    Bool                Hotkey;         /* For Device Switch Hotkey, If it's TRUE,
                                         * driver will use int10 module to set mode */
    Bool                IsSpreadSpectrumEnabled;
    Bool                TwoLCD;         /*=* For Advantech Project, support two LCD MHS *=*/
    Bool                DuoView;        /*=* DuoView, only support for CN400 *=*/
    Bool                UseIGA2;
    Bool                CLE266A2;
    Bool                UseBIOS;

    Bool                DVIAttach;
    Bool                LCDAttach;
    
    Bool                Panning;        /* Virtual Desktop or Not ? */
    
    Bool                EPIA_DVI;       /*for support DVI on EPIA*/   
    int                 IsDemoBoard;    /*for CN400 only ,DVI use DVP1/DVP1*/

    int                 DFPDIPort;
    int                 CRTDIPort;
    int                 OptRefresh;
    int                 Refresh;
    int                 FoundRefresh;

    CRTSETTINGINFO      CRTSettingInfo;
    TMDSSETTINGINFO     TMDSSettingInfo;
    LVDSSETTINGINFO     LVDSSettingInfo;    /* For LCD1. */
    
    /* For dual devices, like dual LCD. Only for VT3324 now. */
    LVDSSETTINGINFO     LVDSSettingInfo2;   /* For LCD2. */
    CRTSETTINGINFO      CRTSettingInfo2;    /* For CRT2 on VT1625. */
 
    /* IGA setting */
    IGASETTINGINFO      IGA1SettingInfo;
    IGASETTINGINFO      IGA2SettingInfo;

    USERDPASETTINGINFO  UserDPASettingInfo;
    
    /* LCD Simultaneous Expand Mode HWCursor Y Scale */
    Bool                scaleY;
    int                 resY;

    /* Some Used Member of ScrnInfoRec */
    int                 bitsPerPixel;   /* fb bpp */
    int                 displayWidth;   /* memory pitch */
    int                 frameX1;        /* viewport position */
    int                 frameY1;
    int                 SaveframeX1;
    int                 SaveframeY1;
    int                 VirtualX;
    int                 VirtualY;
    int                 ActualDesktopSizeX;
    int                 ActualDesktopSizeY;

    /* Some Used Member of DisplayModeRec */
    int                 Clock;          /* pixel clock freq */
    int                 HTotal;
    int                 VTotal;
    int                 HDisplay;       /* horizontal timing */
    int                 VDisplay;       /* vertical timing */
    int                 SaveHDisplay;
    int                 SaveVDisplay;
    int                 CrtcHDisplay;
    int                 CrtcVDisplay;
    int                 SaveCrtcHDisplay;
    int                 SaveCrtcVDisplay;
    int                 SaveVirtualX;
    int                 SaveVirtualY;

    /* I2C & DDC */
    GPIOI2C_INFO        GPIOI2CInfo;
    I2CBusPtr           I2C_Port1;
    I2CBusPtr           I2C_Port2;
    xf86MonPtr          DDC1;
    xf86MonPtr          DDC2;
    I2CDevPtr           dev;

    /* MHS */
    CARD16              PrimaryDevice;
    Bool                SAMM;           /* SAMM success or not? */
    Bool                IsSecondary;
    Bool                HasSecondary;

    /* Utility User Setting */
    LOCO                colors[256];    /* Gamma value */
    CARD8               SuspendTurnOFFDevice; 
    Bool                s3utility;     /*The function call is from s3utility*/    

    /* for mergedfb*/
    VIAFBLayout         CurrentLayout;
    Bool                MergedFB;
    VIAScrn2Rel         Scrn2Position;
    
    int                 maxScrn1_X1, maxScrn1_X2, maxScrn1_Y1, maxScrn1_Y2;
    int                 maxScrn2_X1, maxScrn2_X2, maxScrn2_Y1, maxScrn2_Y2;
    Bool                UseVIAXinerama;
    
    ExtensionEntry*     XineramaExtEntry;
    int                 VIAXineramaVX, VIAXineramaVY;
    
    int                 HalfLine;
    unsigned long       HalfScreen;
    
    int                 CursorStart;

    /* For option: driver version */
    int                 DriverVersionPatchLevel;

    /* For utility api. */
    ExtensionEntry*     DisplayExtEntry;

    /* For hardware rotation used. */
    int                 HWRotate;

    /* For MAMM, VIA is secondary display device. */
    Bool                IsMAMMEnable;

    /* Move NoDDCValue from VIAPtr struct to here. */
    Bool                NoDDCValue;

    /* For Down Scale Used */    
    Bool                IsDownScaleEnable;
    int                 HorDownScaleSize;
    int                 VerDownScaleSize;

    /* For interlace mode. */
    Bool                IsEnableInterlaceMode;
} VIABIOSInfoRec, *VIABIOSInfoPtr;

typedef struct _VIASUPPORTMODE {
    char  Name[10];
    int   ModeIndex;
    int   HActive;
    int   VActive;
} VIASUPPORTMODE;


/* Functions protype */

char* VIAGetBIOSInfo(VIABIOSInfoPtr pBIOSInfo);
unsigned char VIAGetActiveDisplay(VIABIOSInfoPtr pBIOSInfo);
unsigned char VIAGetDeviceDetect(VIABIOSInfoPtr pBIOSInfo);
Bool VIAGetBIOSTable(VIABIOSInfoPtr pBIOSInfo);
Bool VIAFindRefreshRate(VIABIOSInfoPtr pBIOSInfo, int ModeIndex);
Bool VIAFindModeUseModeList(VIABIOSInfoPtr pBIOSInfo);
Bool VIAFindModeUseBIOSTable(VIABIOSInfoPtr pBIOSInfo);
Bool VIASetModeUseBIOSTable(VIABIOSInfoPtr pBIOSInfo);
Bool VIASetModeForMHS(VIABIOSInfoPtr pBIOSInfo);
Bool VIASaveGamma(ScrnInfoPtr pScrn, LOCO *colors);
Bool VIARestoreGamma(ScrnInfoPtr pScrn, LOCO *colors);
void VIADelayIn_usec(VIABIOSInfoPtr pBIOSInfo, int usec);
Bool VIASetMode(VIABIOSInfoPtr pBIOSInfo);
void VIACRTDisable(void);
void VIACRTEnable(void);
void VIASetOutputPath(VIABIOSInfoPtr pBIOSInfo, int device, int set_iga, int output_interface);
void VIASetCRTOutputPath(VIABIOSInfoPtr pBIOSInfo, int set_iga, int output_interface);
void VIACRTSetMode(VIABIOSInfoPtr pBIOSInfo, int vmode_index, int set_iga);
Bool VIASenseCRT(ScrnInfoPtr pScrn);
int VIAGetModeIndex(int HorResolution, int VerResolution);

int BIOS_GetBIOSVersion(ScrnInfoPtr pScrn);
unsigned char BIOS_GetActiveDevice(ScrnInfoPtr pScrn);
Bool BIOS_GetBIOSDate(ScrnInfoPtr pScrn);
Bool BIOS_SetActiveDevice(ScrnInfoPtr pScrn);
int BIOS_QueryModeList(ScrnInfoPtr pScrn, int serno, int* ModeNo);
Bool BIOS_GetVESAModeInfo(ScrnInfoPtr pScrn, int ModeNo, int* Xres, int* Yres, int* bpp);
int BIOS_QuerySupportRefreshRate(ScrnInfoPtr pScrn, int ModeNo, int serno, int* refIndex);
Bool BIOS_SetFlatPanelState(ScrnInfoPtr pScrn, Bool expansion);
Bool VIACorrectMonitorSize(int* MonitorH, int* MonitorV); 
void VIAGetModeSizeByName(char *pName, int *pHSize, int *pVSize);
void VIAGetModeSizeByIndex(int ModeIndex, CARD32 *pHSize, CARD32 *pVSize);
CARD32 VIAGetPixelClockByMode(CARD32 ModeIndex);
void VIAReduceBlanking(VIABIOSInfoPtr pBIOSInfo, CARD32 ModeIndex, CARD32 DeviceType);

/* in via_bandwidth.c */
void VIADisabledExtendedFIFO(VIABIOSInfoPtr pBIOSInfo);
void VIAEnabledPrimaryExtendedFIFO(VIABIOSInfoPtr pBIOSInfo);
void VIAEnabledSecondaryExtendedFIFO(VIABIOSInfoPtr pBIOSInfo);
void VIAFillExpireNumber(VIABIOSInfoPtr pBIOSInfo);
void VIASetDPA_Gfx(int DIPort, GFX_DPA_VALUE_PTR pGfxDPASetting);
void ViaModesAttachHelper(ScrnInfoPtr pScrn, MonPtr monitorp, DisplayModePtr Modes);

/* Down Scaling Functions */
void VIASetDownScaleOffsetReg(ScrnInfoPtr pScrn);
void VIASetDownScaleFactor(ScrnInfoPtr pScrn, int DownScaleHSize, int DownScaleVSize);
void VIASetDownScalingEngineReg(ScrnInfoPtr pScrn, int IGAPath);
void VIADisableDownScaling(ScrnInfoPtr pScrn);

CARD32  VIAGetRevisionOfVX800();

#endif  /* _VIA_BIOS_H_ */

